# Release notes for Gluster 11.2

This is a bugfix release. The release notes for [11.2](11.2.md) contains a listing of all the new improvements and bugs fixed in the GlusterFS 11.2 release.

**NOTE:**
- Next minor release tentative date: Release will be based on requirement only
- Users are highly encouraged to upgrade to newer releases of GlusterFS.

## Important fixes in this release
- Regression suite tests failures are addressed

## Builds are available at

[https://github.com/gluster/glusterfs/releases](https://github.com/gluster/glusterfs/releases)

## Issues addressed in this release

[#4561](https://github.com/gluster/glusterfs/pull/4561) afr: fix race between __afr_eager_lock_handle and afr_wakeup_same_fd_delayed_op
[#4562](https://github.com/gluster/glusterfs/pull/4562) tests: robustness enhancement of regression tests 
[#4563](https://github.com/gluster/glusterfs/pull/4563) events: avoid zombie processes after reloading 
[#4564](https://github.com/gluster/glusterfs/pull/4564) Fix cluster.rc tests with a hack for now 
[#4565](https://github.com/gluster/glusterfs/pull/4565) Increase xfs partition size to 300M 
[#4566](https://github.com/gluster/glusterfs/pull/4566) Trigger read txn to trigger heal
[#4567](https://github.com/gluster/glusterfs/pull/4567) Trigger read txn to trigger heal
[#4568](https://github.com/gluster/glusterfs/pull/4568) Fix compilation error for test run
[#4569](https://github.com/gluster/glusterfs/pull/4569) Disable write-behind to prevent close-behind
[#4570](https://github.com/gluster/glusterfs/pull/4570) tests: address XFS 300M minimum size
[#4571](https://github.com/gluster/glusterfs/pull/4571) Fix lvm setup so that snapshot tests pass
[#4572](https://github.com/gluster/glusterfs/pull/4572) Adjust sizes based on free size available
[#4573](https://github.com/gluster/glusterfs/pull/4573) Adjust min xfs fs size
[#4574](https://github.com/gluster/glusterfs/pull/4574) Fix the pattern to be matched
[#4575](https://github.com/gluster/glusterfs/pull/4575) s/gawk/awk
[#4576](https://github.com/gluster/glusterfs/pull/4576) Deduplication of changelogs in a batch
[#4577](https://github.com/gluster/glusterfs/pull/4577) create home directory for user
[#4579](https://github.com/gluster/glusterfs/pull/4579) glusterfsd/mgmt: Connect backup volfile-server in round robin
[#4580](https://github.com/gluster/glusterfs/pull/4580) glfs/open: dentry lists are not initialized
[#4581](https://github.com/gluster/glusterfs/pull/4581) api/glfs: Fix use after free in readdir
[#4582](https://github.com/gluster/glusterfs/pull/4582) shd/symlink: soft links entry recreate fails
[#4583](https://github.com/gluster/glusterfs/pull/4583) extras: use "grep -E" instead of egrep to resolve warning
